/* A Bison parser, made by GNU Bison 3.7.6.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30706

/* Bison version string.  */
#define YYBISON_VERSION "3.7.6"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         master_parse
#define yylex           master_lex
#define yyerror         master_error
#define yydebug         master_debug
#define yynerrs         master_nerrs
#define yylval          master_lval
#define yychar          master_char

/* First part of user prologue.  */
#line 1 "master_parse.y"

/* ----------------------------------------------------------------------- *
 *   
 *  master_parser.y - master map buffer parser.
 *
 *   Copyright 2006 Ian Kent <raven@themaw.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, Inc., 675 Mass Ave, Cambridge MA 02139,
 *   USA; either version 2 of the License, or (at your option) any later
 *   version.
 *   
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 * ----------------------------------------------------------------------- */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <ctype.h>
#include <sys/ioctl.h>

#include "automount.h"
#include "master.h"

#define MAX_ERR_LEN	512

extern struct master *master_list;

char **add_argv(int, char **, char *);
const char **copy_argv(int, const char **);
int free_argv(int, const char **);

extern FILE *master_in;
extern char *master_text;
extern int master_lex(void);
extern int master_lineno;
extern void master_set_scan_buffer(const char *);

static char *master_strdup(char *);
static void local_init_vars(void);
static void local_free_vars(void);
static void trim_maptype(char *);
static int add_multi_mapstr(void);

static int master_error(const char *s);
static int master_notify(const char *s);
static int master_msg(const char *s);
 
static char *path;
static char *type;
static char *format;
static long timeout;
static long negative_timeout;
static unsigned symlnk;
static unsigned nobind;
static unsigned ghost;
extern unsigned global_selection_options;
static unsigned random_selection;
static unsigned use_weight;
static unsigned long mode;
static char **tmp_argv;
static int tmp_argc;
static char **local_argv;
static int local_argc;

static char errstr[MAX_ERR_LEN];

static unsigned int verbose;
static unsigned int debug;

static int lineno;

#define YYDEBUG 0

#ifndef YYENABLE_NLS
#define YYENABLE_NLS 0
#endif
#ifndef YYLTYPE_IS_TRIVIAL
#define YYLTYPE_IS_TRIVIAL 0
#endif

#if YYDEBUG
static int master_fprintf(FILE *, char *, ...);
#undef YYFPRINTF
#define YYFPRINTF master_fprintf
#endif


#line 173 "master_parse.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "master_parse.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_COMMENT = 3,                    /* COMMENT  */
  YYSYMBOL_MAP = 4,                        /* MAP  */
  YYSYMBOL_OPT_TIMEOUT = 5,                /* OPT_TIMEOUT  */
  YYSYMBOL_OPT_NTIMEOUT = 6,               /* OPT_NTIMEOUT  */
  YYSYMBOL_OPT_NOBIND = 7,                 /* OPT_NOBIND  */
  YYSYMBOL_OPT_NOGHOST = 8,                /* OPT_NOGHOST  */
  YYSYMBOL_OPT_GHOST = 9,                  /* OPT_GHOST  */
  YYSYMBOL_OPT_VERBOSE = 10,               /* OPT_VERBOSE  */
  YYSYMBOL_OPT_DEBUG = 11,                 /* OPT_DEBUG  */
  YYSYMBOL_OPT_RANDOM = 12,                /* OPT_RANDOM  */
  YYSYMBOL_OPT_USE_WEIGHT = 13,            /* OPT_USE_WEIGHT  */
  YYSYMBOL_OPT_SYMLINK = 14,               /* OPT_SYMLINK  */
  YYSYMBOL_OPT_MODE = 15,                  /* OPT_MODE  */
  YYSYMBOL_COLON = 16,                     /* COLON  */
  YYSYMBOL_COMMA = 17,                     /* COMMA  */
  YYSYMBOL_NL = 18,                        /* NL  */
  YYSYMBOL_DDASH = 19,                     /* DDASH  */
  YYSYMBOL_PATH = 20,                      /* PATH  */
  YYSYMBOL_QUOTE = 21,                     /* QUOTE  */
  YYSYMBOL_NILL = 22,                      /* NILL  */
  YYSYMBOL_SPACE = 23,                     /* SPACE  */
  YYSYMBOL_EQUAL = 24,                     /* EQUAL  */
  YYSYMBOL_MULTITYPE = 25,                 /* MULTITYPE  */
  YYSYMBOL_MAPTYPE = 26,                   /* MAPTYPE  */
  YYSYMBOL_DNSERVER = 27,                  /* DNSERVER  */
  YYSYMBOL_DNATTR = 28,                    /* DNATTR  */
  YYSYMBOL_DNNAME = 29,                    /* DNNAME  */
  YYSYMBOL_MAPHOSTS = 30,                  /* MAPHOSTS  */
  YYSYMBOL_MAPNULL = 31,                   /* MAPNULL  */
  YYSYMBOL_MAPXFN = 32,                    /* MAPXFN  */
  YYSYMBOL_MAPNAME = 33,                   /* MAPNAME  */
  YYSYMBOL_NUMBER = 34,                    /* NUMBER  */
  YYSYMBOL_OCTALNUMBER = 35,               /* OCTALNUMBER  */
  YYSYMBOL_OPTION = 36,                    /* OPTION  */
  YYSYMBOL_YYACCEPT = 37,                  /* $accept  */
  YYSYMBOL_file = 38,                      /* file  */
  YYSYMBOL_39_1 = 39,                      /* $@1  */
  YYSYMBOL_line = 40,                      /* line  */
  YYSYMBOL_mapspec = 41,                   /* mapspec  */
  YYSYMBOL_maplist = 42,                   /* maplist  */
  YYSYMBOL_map = 43,                       /* map  */
  YYSYMBOL_dn = 44,                        /* dn  */
  YYSYMBOL_dnattrs = 45,                   /* dnattrs  */
  YYSYMBOL_dnattr = 46,                    /* dnattr  */
  YYSYMBOL_options = 47,                   /* options  */
  YYSYMBOL_option = 48,                    /* option  */
  YYSYMBOL_daemon_option = 49,             /* daemon_option  */
  YYSYMBOL_mount_option = 50               /* mount_option  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   218

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  37
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  14
/* YYNRULES -- Number of rules.  */
#define YYNRULES  70
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  83

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   291


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   137,   137,   137,   145,   146,   154,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   205,   212,   221,   229,   237,
     252,   269,   279,   289,   297,   303,   311,   326,   360,   394,
     444,   449,   454,   460,   476,   494,   499,   506,   520,   536,
     541,   548,   549,   550,   551,   556,   563,   564,   565,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     585
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "COMMENT", "MAP",
  "OPT_TIMEOUT", "OPT_NTIMEOUT", "OPT_NOBIND", "OPT_NOGHOST", "OPT_GHOST",
  "OPT_VERBOSE", "OPT_DEBUG", "OPT_RANDOM", "OPT_USE_WEIGHT",
  "OPT_SYMLINK", "OPT_MODE", "COLON", "COMMA", "NL", "DDASH", "PATH",
  "QUOTE", "NILL", "SPACE", "EQUAL", "MULTITYPE", "MAPTYPE", "DNSERVER",
  "DNATTR", "DNNAME", "MAPHOSTS", "MAPNULL", "MAPXFN", "MAPNAME", "NUMBER",
  "OCTALNUMBER", "OPTION", "$accept", "file", "$@1", "line", "mapspec",
  "maplist", "map", "dn", "dnattrs", "dnattr", "options", "option",
  "daemon_option", "mount_option", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291
};
#endif

#define YYPACT_NINF (-25)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-31)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -25,     1,   139,   -25,   -25,   158,   -25,   -25,   -25,   -25,
     -25,   -25,   -25,   -25,   -25,   -25,   -25,   -25,   -25,   -25,
     -25,   -25,   -25,   185,     0,     6,   -25,   -25,   -25,   -25,
     -25,   -25,   -25,   111,   -25,   -13,    74,   -25,   -24,   -25,
     -25,   -25,    -4,   -25,    -3,    16,   -25,   -25,   -25,   -25,
     -25,   -25,   -25,   -25,    21,   -25,    54,   -25,   -25,   -25,
     185,     2,   -25,    15,   -25,   -25,   -25,   126,   -25,   -25,
      94,    -5,   143,   -25,    34,    33,   -25,   -25,   -25,    43,
      56,    -5,   -25
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       2,     0,     4,     1,    24,    20,    21,    23,    22,     3,
      13,    15,    17,    16,    18,    12,    10,    11,    14,    19,
       7,    31,     9,     0,    42,    46,    45,    33,    35,    34,
      32,     8,     5,     0,    36,     6,     0,    37,     0,    38,
      39,    41,     0,    58,     0,     0,    62,    63,    64,    65,
      66,    67,    68,    61,     0,    70,     0,    51,    56,    57,
       0,     0,    40,    43,    59,    60,    69,     0,    55,    53,
       0,     0,     0,    52,     0,    49,    50,    44,    54,     0,
      47,     0,    48
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -25,   -25,   -25,   -25,   -25,   -25,   -23,   -25,    -2,    10,
     -18,   136,   -25,   -25
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
       0,     1,     2,     9,    32,    35,    33,    40,    34,    77,
      56,    57,    58,    59
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int8 yytable[] =
{
      36,     3,   -28,    43,    25,    26,    60,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    61,    67,
      37,   -28,    41,    75,    76,    63,    68,    38,    25,    26,
      42,    64,    71,    39,   -30,    43,    62,    70,    55,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      65,    67,    74,   -30,   -26,    43,    66,    79,    68,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    67,    80,    81,   -27,    43,     0,     0,    68,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    82,     0,   -27,   -29,    43,     0,     0,     0,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,   -25,    43,   -29,     0,     0,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    43,     0,     0,
      55,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,     4,    72,    43,     0,     0,    55,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,     5,
       6,     7,    55,    10,     0,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,     8,     0,     0,    21,    55,
      22,     0,     0,    23,    24,     0,    25,    26,    27,    28,
      29,    30,    69,     0,    31,     0,     0,    69,     0,     0,
       0,     0,     0,    73,     0,    21,     0,     0,    78,     0,
      69,    24,     0,    25,    26,    27,    28,    29,    30
};

static const yytype_int8 yycheck[] =
{
      23,     0,     0,     1,    28,    29,    19,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    36,    17,
      20,    19,    24,    28,    29,    29,    24,    27,    28,    29,
      24,    34,    17,    33,     0,     1,    38,    60,    36,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      34,    17,    70,    19,     0,     1,    35,    24,    24,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      36,    17,    29,    17,     0,     1,    -1,    -1,    24,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      36,    81,    -1,    19,     0,     1,    -1,    -1,    -1,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      36,     0,     1,    19,    -1,    -1,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,     1,    -1,    -1,
      36,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,     3,    17,     1,    -1,    -1,    36,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    20,
      21,    22,    36,     5,    -1,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    36,    -1,    -1,    20,    36,
      22,    -1,    -1,    25,    26,    -1,    28,    29,    30,    31,
      32,    33,    56,    -1,    36,    -1,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    67,    -1,    20,    -1,    -1,    72,    -1,
      74,    26,    -1,    28,    29,    30,    31,    32,    33
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    38,    39,     0,     3,    20,    21,    22,    36,    40,
       5,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    20,    22,    25,    26,    28,    29,    30,    31,    32,
      33,    36,    41,    43,    45,    42,    43,    20,    27,    33,
      44,    45,    24,     1,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    36,    47,    48,    49,    50,
      19,    47,    45,    29,    34,    34,    35,    17,    24,    48,
      43,    17,    17,    48,    47,    28,    29,    46,    48,    24,
      29,    17,    46
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int8 yyr1[] =
{
       0,    37,    39,    38,    40,    40,    40,    40,    40,    40,
      40,    40,    40,    40,    40,    40,    40,    40,    40,    40,
      40,    40,    40,    40,    40,    41,    41,    42,    42,    42,
      42,    43,    43,    43,    43,    43,    43,    43,    43,    43,
      44,    44,    44,    45,    45,    45,    45,    46,    46,    46,
      46,    47,    47,    47,    47,    47,    48,    48,    48,    49,
      49,    49,    49,    49,    49,    49,    49,    49,    49,    49,
      50
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     0,     2,     3,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       1,     1,     1,     1,     1,     1,     2,     1,     2,     3,
       4,     1,     1,     1,     1,     1,     1,     2,     2,     2,
       2,     1,     0,     3,     5,     1,     1,     3,     5,     1,
       1,     1,     3,     2,     4,     2,     1,     1,     1,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* $@1: %empty  */
#line 137 "master_parse.y"
      {
		master_lineno = 0;
#if YYDEBUG != 0
		master_debug = YYDEBUG;
#endif
	}
#line 1311 "master_parse.tab.c"
    break;

  case 5: /* line: PATH mapspec  */
#line 147 "master_parse.y"
        {
		path = master_strdup((yyvsp[-1].strtype));
		if (!path) {
			local_free_vars();
			YYABORT;
		}
	}
#line 1323 "master_parse.tab.c"
    break;

  case 6: /* line: PATH MULTITYPE maplist  */
#line 155 "master_parse.y"
        {
		char *tmp = NULL;

		trim_maptype((yyvsp[-1].strtype));

		path = master_strdup((yyvsp[-2].strtype));
		if (!path) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}

		if ((tmp = strchr((yyvsp[-1].strtype), ',')))
			*tmp++ = '\0';

		type = master_strdup((yyvsp[-1].strtype));
		if (!type) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
		if (tmp) {
			format = master_strdup(tmp);
			if (!format) {
				master_error("memory allocation error");
				local_free_vars();
				YYABORT;
			}
		}
	}
#line 1358 "master_parse.tab.c"
    break;

  case 7: /* line: PATH COLON  */
#line 185 "master_parse.y"
                     { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1364 "master_parse.tab.c"
    break;

  case 8: /* line: PATH OPTION  */
#line 186 "master_parse.y"
                      { master_notify((yyvsp[0].strtype)); YYABORT; }
#line 1370 "master_parse.tab.c"
    break;

  case 9: /* line: PATH NILL  */
#line 187 "master_parse.y"
                    { master_notify((yyvsp[0].strtype)); YYABORT; }
#line 1376 "master_parse.tab.c"
    break;

  case 10: /* line: PATH OPT_RANDOM  */
#line 188 "master_parse.y"
                          { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1382 "master_parse.tab.c"
    break;

  case 11: /* line: PATH OPT_USE_WEIGHT  */
#line 189 "master_parse.y"
                              { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1388 "master_parse.tab.c"
    break;

  case 12: /* line: PATH OPT_DEBUG  */
#line 190 "master_parse.y"
                         { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1394 "master_parse.tab.c"
    break;

  case 13: /* line: PATH OPT_TIMEOUT  */
#line 191 "master_parse.y"
                           { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1400 "master_parse.tab.c"
    break;

  case 14: /* line: PATH OPT_SYMLINK  */
#line 192 "master_parse.y"
                           { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1406 "master_parse.tab.c"
    break;

  case 15: /* line: PATH OPT_NOBIND  */
#line 193 "master_parse.y"
                          { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1412 "master_parse.tab.c"
    break;

  case 16: /* line: PATH OPT_GHOST  */
#line 194 "master_parse.y"
                         { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1418 "master_parse.tab.c"
    break;

  case 17: /* line: PATH OPT_NOGHOST  */
#line 195 "master_parse.y"
                           { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1424 "master_parse.tab.c"
    break;

  case 18: /* line: PATH OPT_VERBOSE  */
#line 196 "master_parse.y"
                           { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1430 "master_parse.tab.c"
    break;

  case 19: /* line: PATH OPT_MODE  */
#line 197 "master_parse.y"
                        { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1436 "master_parse.tab.c"
    break;

  case 20: /* line: PATH  */
#line 198 "master_parse.y"
               { master_notify((yyvsp[0].strtype)); YYABORT; }
#line 1442 "master_parse.tab.c"
    break;

  case 21: /* line: QUOTE  */
#line 199 "master_parse.y"
                { master_notify((yyvsp[0].strtype)); YYABORT; }
#line 1448 "master_parse.tab.c"
    break;

  case 22: /* line: OPTION  */
#line 200 "master_parse.y"
                 { master_notify((yyvsp[0].strtype)); YYABORT; }
#line 1454 "master_parse.tab.c"
    break;

  case 23: /* line: NILL  */
#line 201 "master_parse.y"
               { master_notify((yyvsp[0].strtype)); YYABORT; }
#line 1460 "master_parse.tab.c"
    break;

  case 24: /* line: COMMENT  */
#line 202 "master_parse.y"
                  { YYABORT; }
#line 1466 "master_parse.tab.c"
    break;

  case 25: /* mapspec: map  */
#line 206 "master_parse.y"
        {
		local_argc = tmp_argc;
		local_argv = tmp_argv;
		tmp_argc = 0;
		tmp_argv = NULL;
	}
#line 1477 "master_parse.tab.c"
    break;

  case 26: /* mapspec: map options  */
#line 213 "master_parse.y"
        {
		local_argc = tmp_argc;
		local_argv = tmp_argv;
		tmp_argc = 0;
		tmp_argv = NULL;
	}
#line 1488 "master_parse.tab.c"
    break;

  case 27: /* maplist: map  */
#line 222 "master_parse.y"
        {
		if (!add_multi_mapstr()) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
	}
#line 1500 "master_parse.tab.c"
    break;

  case 28: /* maplist: map options  */
#line 230 "master_parse.y"
        {
		if (!add_multi_mapstr()) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
	}
#line 1512 "master_parse.tab.c"
    break;

  case 29: /* maplist: maplist DDASH map  */
#line 238 "master_parse.y"
        {
		local_argc++;
		local_argv = add_argv(local_argc, local_argv, "--");
		if (!local_argv) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
		if (!add_multi_mapstr()) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
	}
#line 1531 "master_parse.tab.c"
    break;

  case 30: /* maplist: maplist DDASH map options  */
#line 253 "master_parse.y"
        {
		local_argc++;
		local_argv = add_argv(local_argc, local_argv, "--");
		if (!local_argv) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
		if (!add_multi_mapstr()) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
	}
#line 1550 "master_parse.tab.c"
    break;

  case 31: /* map: PATH  */
#line 270 "master_parse.y"
        {
		tmp_argc++;
		tmp_argv = add_argv(tmp_argc, tmp_argv, (yyvsp[0].strtype));
		if (!tmp_argv) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
	}
#line 1564 "master_parse.tab.c"
    break;

  case 32: /* map: MAPNAME  */
#line 280 "master_parse.y"
        {
		tmp_argc++;
		tmp_argv = add_argv(tmp_argc, tmp_argv, (yyvsp[0].strtype));
		if (!tmp_argv) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
	}
#line 1578 "master_parse.tab.c"
    break;

  case 33: /* map: MAPHOSTS  */
#line 290 "master_parse.y"
        {
		type = master_strdup((yyvsp[0].strtype) + 1);
		if (!type) {
			local_free_vars();
			YYABORT;
		}
	}
#line 1590 "master_parse.tab.c"
    break;

  case 34: /* map: MAPXFN  */
#line 298 "master_parse.y"
        {
		master_notify((yyvsp[0].strtype));
		master_msg("X/Open Federated Naming service not supported");
		YYABORT;
	}
#line 1600 "master_parse.tab.c"
    break;

  case 35: /* map: MAPNULL  */
#line 304 "master_parse.y"
        {
		type = master_strdup((yyvsp[0].strtype) + 1);
		if (!type) {
			local_free_vars();
			YYABORT;
		}
	}
#line 1612 "master_parse.tab.c"
    break;

  case 36: /* map: dnattrs  */
#line 312 "master_parse.y"
        {
		type = master_strdup("ldap");
		if (!type) {
			local_free_vars();
			YYABORT;
		}
		tmp_argc++;
		tmp_argv = add_argv(tmp_argc, tmp_argv, (yyvsp[0].strtype));
		if (!tmp_argv) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
	}
#line 1631 "master_parse.tab.c"
    break;

  case 37: /* map: MAPTYPE PATH  */
#line 327 "master_parse.y"
        {
		char *tmp = NULL;

		trim_maptype((yyvsp[-1].strtype));

		if ((tmp = strchr((yyvsp[-1].strtype), ',')))
			*tmp++ = '\0';

		if (strcmp((yyvsp[-1].strtype), "exec"))
			type = master_strdup((yyvsp[-1].strtype));
		else
			type = master_strdup("program");
		if (!type) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
		if (tmp) {
			format = master_strdup(tmp);
			if (!format) {
				master_error("memory allocation error");
				local_free_vars();
				YYABORT;
			}
		}
		tmp_argc++;
		tmp_argv = add_argv(tmp_argc, tmp_argv, (yyvsp[0].strtype));
		if (!tmp_argv) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
	}
#line 1669 "master_parse.tab.c"
    break;

  case 38: /* map: MAPTYPE MAPNAME  */
#line 361 "master_parse.y"
        {
		char *tmp = NULL;

		trim_maptype((yyvsp[-1].strtype));

		if ((tmp = strchr((yyvsp[-1].strtype), ',')))
			*tmp++ = '\0';

		if (strcmp((yyvsp[-1].strtype), "exec"))
			type = master_strdup((yyvsp[-1].strtype));
		else
			type = master_strdup("program");
		if (!type) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
		if (tmp) {
			format = master_strdup(tmp);
			if (!format) {
				master_error("memory allocation error");
				local_free_vars();
				YYABORT;
			}
		}
		tmp_argc++;
		tmp_argv = add_argv(tmp_argc, tmp_argv, (yyvsp[0].strtype));
		if (!tmp_argv) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
	}
#line 1707 "master_parse.tab.c"
    break;

  case 39: /* map: MAPTYPE dn  */
#line 395 "master_parse.y"
        {
		char *tmp = NULL;

		trim_maptype((yyvsp[-1].strtype));

		if ((tmp = strchr((yyvsp[-1].strtype), ',')))
			*tmp++ = '\0';

		if (strcmp((yyvsp[-1].strtype), "exec"))
			type = master_strdup((yyvsp[-1].strtype));
		else
			type = master_strdup("program");
		if (!type) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
		if (tmp) {
			format = master_strdup(tmp);
			if (!format) {
				master_error("memory allocation error");
				local_free_vars();
				YYABORT;
			}
		}
		tmp_argc++;
		tmp_argv = add_argv(tmp_argc, tmp_argv, (yyvsp[0].strtype));
		if (!tmp_argv) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
		/* Add back the type for lookup_ldap.c to handle ldaps */
		if (*tmp_argv[0]) {
			tmp = malloc(strlen(type) + strlen(tmp_argv[0]) + 2);
			if (!tmp) {
				master_error("memory allocation error");
				local_free_vars();
				YYABORT;
			}
			strcpy(tmp, type);
			strcat(tmp, ":");
			strcat(tmp, tmp_argv[0]);
			free(tmp_argv[0]);
			tmp_argv[0] = tmp;
		}
	}
#line 1759 "master_parse.tab.c"
    break;

  case 40: /* dn: DNSERVER dnattrs  */
#line 445 "master_parse.y"
        {
		strcpy((yyval.strtype), (yyvsp[-1].strtype));
		strcat((yyval.strtype), (yyvsp[0].strtype));
	}
#line 1768 "master_parse.tab.c"
    break;

  case 41: /* dn: dnattrs  */
#line 450 "master_parse.y"
        {
		strcpy((yyval.strtype), (yyvsp[0].strtype));
	}
#line 1776 "master_parse.tab.c"
    break;

  case 42: /* dn: %empty  */
#line 454 "master_parse.y"
        {
		master_notify("syntax error in dn");
		YYABORT;
	}
#line 1785 "master_parse.tab.c"
    break;

  case 43: /* dnattrs: DNATTR EQUAL DNNAME  */
#line 461 "master_parse.y"
        {
		if (strcasecmp((yyvsp[-2].strtype), "cn") &&
		    strcasecmp((yyvsp[-2].strtype), "ou") &&
		    strcasecmp((yyvsp[-2].strtype), "automountMapName") &&
		    strcasecmp((yyvsp[-2].strtype), "nisMapName")) {
			strcpy(errstr, (yyvsp[-2].strtype));
			strcat(errstr, "=");
			strcat(errstr, (yyvsp[0].strtype));
			master_notify(errstr);
			YYABORT;
		}
		strcpy((yyval.strtype), (yyvsp[-2].strtype));
		strcat((yyval.strtype), "=");
		strcat((yyval.strtype), (yyvsp[0].strtype));
	}
#line 1805 "master_parse.tab.c"
    break;

  case 44: /* dnattrs: DNATTR EQUAL DNNAME COMMA dnattr  */
#line 477 "master_parse.y"
        {
		if (strcasecmp((yyvsp[-4].strtype), "cn") &&
		    strcasecmp((yyvsp[-4].strtype), "ou") &&
		    strcasecmp((yyvsp[-4].strtype), "automountMapName") &&
		    strcasecmp((yyvsp[-4].strtype), "nisMapName")) {
			strcpy(errstr, (yyvsp[-4].strtype));
			strcat(errstr, "=");
			strcat(errstr, (yyvsp[-2].strtype));
			master_notify(errstr);
			YYABORT;
		}
		strcpy((yyval.strtype), (yyvsp[-4].strtype));
		strcat((yyval.strtype), "=");
		strcat((yyval.strtype), (yyvsp[-2].strtype));
		strcat((yyval.strtype), ",");
		strcat((yyval.strtype), (yyvsp[0].strtype));
	}
#line 1827 "master_parse.tab.c"
    break;

  case 45: /* dnattrs: DNNAME  */
#line 495 "master_parse.y"
        {
		/* Matches map in old style syntax ldap:server:map */
		strcpy((yyval.strtype), (yyvsp[0].strtype));
	}
#line 1836 "master_parse.tab.c"
    break;

  case 46: /* dnattrs: DNATTR  */
#line 500 "master_parse.y"
        {
		master_notify((yyvsp[0].strtype));
		YYABORT;
	}
#line 1845 "master_parse.tab.c"
    break;

  case 47: /* dnattr: DNATTR EQUAL DNNAME  */
#line 507 "master_parse.y"
        {
		if (!strcasecmp((yyvsp[-2].strtype), "automountMapName") ||
		    !strcasecmp((yyvsp[-2].strtype), "nisMapName")) {
			strcpy(errstr, (yyvsp[-2].strtype));
			strcat(errstr, "=");
			strcat(errstr, (yyvsp[0].strtype));
			master_notify(errstr);
			YYABORT;
		}
		strcpy((yyval.strtype), (yyvsp[-2].strtype));
		strcat((yyval.strtype), "=");
		strcat((yyval.strtype), (yyvsp[0].strtype));
	}
#line 1863 "master_parse.tab.c"
    break;

  case 48: /* dnattr: DNATTR EQUAL DNNAME COMMA dnattr  */
#line 521 "master_parse.y"
        {
		if (!strcasecmp((yyvsp[-4].strtype), "automountMapName") ||
		    !strcasecmp((yyvsp[-4].strtype), "nisMapName")) {
			strcpy(errstr, (yyvsp[-4].strtype));
			strcat(errstr, "=");
			strcat(errstr, (yyvsp[-2].strtype));
			master_notify(errstr);
			YYABORT;
		}
		strcpy((yyval.strtype), (yyvsp[-4].strtype));
		strcat((yyval.strtype), "=");
		strcat((yyval.strtype), (yyvsp[-2].strtype));
		strcat((yyval.strtype), ",");
		strcat((yyval.strtype), (yyvsp[0].strtype));
	}
#line 1883 "master_parse.tab.c"
    break;

  case 49: /* dnattr: DNATTR  */
#line 537 "master_parse.y"
        {
		master_notify((yyvsp[0].strtype));
		YYABORT;
	}
#line 1892 "master_parse.tab.c"
    break;

  case 50: /* dnattr: DNNAME  */
#line 542 "master_parse.y"
        {
		master_notify((yyvsp[0].strtype));
		YYABORT;
	}
#line 1901 "master_parse.tab.c"
    break;

  case 51: /* options: option  */
#line 548 "master_parse.y"
                {}
#line 1907 "master_parse.tab.c"
    break;

  case 52: /* options: options COMMA option  */
#line 549 "master_parse.y"
                               {}
#line 1913 "master_parse.tab.c"
    break;

  case 53: /* options: options option  */
#line 550 "master_parse.y"
                         {}
#line 1919 "master_parse.tab.c"
    break;

  case 54: /* options: options COMMA COMMA option  */
#line 552 "master_parse.y"
        {
		master_notify((yyvsp[-3].strtype));
		YYABORT;
	}
#line 1928 "master_parse.tab.c"
    break;

  case 55: /* options: options EQUAL  */
#line 557 "master_parse.y"
        {
		master_notify((yyvsp[-1].strtype));
		YYABORT;
	}
#line 1937 "master_parse.tab.c"
    break;

  case 57: /* option: mount_option  */
#line 564 "master_parse.y"
                       {}
#line 1943 "master_parse.tab.c"
    break;

  case 58: /* option: error  */
#line 566 "master_parse.y"
        {
		master_notify("bogus option");
		YYABORT;
	}
#line 1952 "master_parse.tab.c"
    break;

  case 59: /* daemon_option: OPT_TIMEOUT NUMBER  */
#line 572 "master_parse.y"
                                  { timeout = (yyvsp[0].longtype); }
#line 1958 "master_parse.tab.c"
    break;

  case 60: /* daemon_option: OPT_NTIMEOUT NUMBER  */
#line 573 "master_parse.y"
                              { negative_timeout = (yyvsp[0].longtype); }
#line 1964 "master_parse.tab.c"
    break;

  case 61: /* daemon_option: OPT_SYMLINK  */
#line 574 "master_parse.y"
                        { symlnk = 1; }
#line 1970 "master_parse.tab.c"
    break;

  case 62: /* daemon_option: OPT_NOBIND  */
#line 575 "master_parse.y"
                        { nobind = 1; }
#line 1976 "master_parse.tab.c"
    break;

  case 63: /* daemon_option: OPT_NOGHOST  */
#line 576 "master_parse.y"
                        { ghost = 0; }
#line 1982 "master_parse.tab.c"
    break;

  case 64: /* daemon_option: OPT_GHOST  */
#line 577 "master_parse.y"
                        { ghost = 1; }
#line 1988 "master_parse.tab.c"
    break;

  case 65: /* daemon_option: OPT_VERBOSE  */
#line 578 "master_parse.y"
                        { verbose = 1; }
#line 1994 "master_parse.tab.c"
    break;

  case 66: /* daemon_option: OPT_DEBUG  */
#line 579 "master_parse.y"
                        { debug = 1; }
#line 2000 "master_parse.tab.c"
    break;

  case 67: /* daemon_option: OPT_RANDOM  */
#line 580 "master_parse.y"
                        { random_selection = 1; }
#line 2006 "master_parse.tab.c"
    break;

  case 68: /* daemon_option: OPT_USE_WEIGHT  */
#line 581 "master_parse.y"
                         { use_weight = 1; }
#line 2012 "master_parse.tab.c"
    break;

  case 69: /* daemon_option: OPT_MODE OCTALNUMBER  */
#line 582 "master_parse.y"
                               { mode = (yyvsp[0].longtype); }
#line 2018 "master_parse.tab.c"
    break;

  case 70: /* mount_option: OPTION  */
#line 586 "master_parse.y"
        {
		tmp_argc++;
		tmp_argv = add_argv(tmp_argc, tmp_argv, (yyvsp[0].strtype));
		if (!tmp_argv) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
	}
#line 2032 "master_parse.tab.c"
    break;


#line 2036 "master_parse.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 596 "master_parse.y"


#if YYDEBUG
static int master_fprintf(FILE *f, char *msg, ...)
{
	va_list ap;
	va_start(ap, msg);
	vsyslog(LOG_DEBUG, msg, ap);
	va_end(ap);
	return 1;
}
#endif

static char *master_strdup(char *str)
{
	char *tmp;

	tmp = strdup(str);
	if (!tmp)
		master_error("memory allocation error");
	return tmp;
}

static int master_error(const char *s)
{
	logmsg("%s while parsing map.", s);
	return 0;
}

static int master_notify(const char *s)
{
	logmsg("syntax error in map near [ %s ]", s);
	return(0);
}

static int master_msg(const char *s)
{
	logmsg("%s", s);
	return 0;
}

static void local_init_vars(void)
{
	path = NULL;
	type = NULL;
	format = NULL;
	verbose = 0;
	debug = 0;
	timeout = -1;
	negative_timeout = 0;
	symlnk = 0;
	nobind = 0;
	ghost = defaults_get_browse_mode();
	random_selection = global_selection_options & MOUNT_FLAG_RANDOM_SELECT;
	use_weight = 0;
	mode = 0;
	tmp_argv = NULL;
	tmp_argc = 0;
	local_argv = NULL;
	local_argc = 0;
}

static void local_free_vars(void)
{
	if (path)
		free(path);

	if (type)
		free(type);

	if (format)
		free(format);

	if (local_argv) {
		free_argv(local_argc, (const char **) local_argv);
		local_argv = NULL;
		local_argc = 0;
	}

	if (tmp_argv) {
		free_argv(tmp_argc, (const char **) tmp_argv);
		tmp_argv = NULL;
		tmp_argc = 0;
	}
}

static void trim_maptype(char *type)
{
	char *tmp;

	tmp = strchr(type, ':');
	if (tmp)
		*tmp = '\0';
	else {
		int len = strlen(type);
		while (len-- && isblank(type[len]))
			type[len] = '\0';
	}
	return;
}

static int add_multi_mapstr(void)
{
	if (type) {
		/* If type given and format is non-null add it back */
		if (format) {
			int len = strlen(type) + strlen(format) + 2;
			char *tmp = realloc(type, len);
			if (!tmp)
				return 0;
			type = tmp;
			strcat(type, ",");
			strcat(type, format);
			free(format);
			format = NULL;
		}

		local_argc++;
		local_argv = add_argv(local_argc, local_argv, type);
		if (!local_argv) {
			free(type);
			type = NULL;
			return 0;
		}

		free(type);
		type = NULL;
	}

	local_argv = append_argv(local_argc, local_argv, tmp_argc, tmp_argv);
	if (!local_argv) {
		free(type);
		type = NULL;
		return 0;
	}
	local_argc += tmp_argc;

	tmp_argc = 0;
	tmp_argv = NULL;

	return 1;
}

void master_init_scan(void)
{
	lineno = 0;
}

int master_parse_entry(const char *buffer, unsigned int default_timeout, unsigned int logging, time_t age)
{
	struct master *master = master_list;
	struct mapent_cache *nc;
	struct master_mapent *entry, *new;
	struct map_source *source;
	unsigned int logopt = logging;
	unsigned int m_logopt = master->logopt;
	int ret;

	local_init_vars();

	lineno++;

	master_set_scan_buffer(buffer);

	ret = master_parse();
	if (ret != 0) {
		local_free_vars();
		return 0;
	}

	nc = master->nc;

	/* Add null map entries to the null map cache */
	if (type && !strcmp(type, "null")) {
		cache_update(nc, NULL, path, NULL, lineno);
		local_free_vars();
		return 1;
	}

	/* Ignore all subsequent matching nulled entries */
	if (cache_lookup_distinct(nc, path)) {
		local_free_vars();
		return 1;
	}

	if (debug || verbose) {
		logopt = (debug ? LOGOPT_DEBUG : 0);
		logopt |= (verbose ? LOGOPT_VERBOSE : 0);
	}

	new = NULL;
	entry = master_find_mapent(master, path);
	if (!entry) {
		new = master_new_mapent(master, path, age);
		if (!new) {
			local_free_vars();
			return 0;
		}
		entry = new;
	} else {
		if (entry->age && entry->age == age) {
			if (strcmp(path, "/-")) {
				info(m_logopt,
				    "ignoring duplicate indirect mount %s",
				     path);
				local_free_vars();
				return 0;
			}
		}
	}

	if (!format) {
		if (conf_amd_mount_section_exists(path))
			format = strdup("amd");
	}

	if (format && !strcmp(format, "amd")) {
		unsigned int loglevel = conf_amd_get_log_options();
		if (loglevel <= LOG_DEBUG && loglevel > LOG_INFO)
			logopt = LOGOPT_DEBUG;
		else if (loglevel <= LOG_INFO && loglevel > LOG_ERR)
			logopt = LOGOPT_VERBOSE;
		/* amd mounts don't support browse mode */
		ghost = 0;
	}


	if (timeout < 0) {
		/*
		 * If no timeout is given get the timout from the
		 * first map (if it exists) or the config for amd
		 * maps.
		 */
		if (format && !strcmp(format, "amd"))
			timeout = conf_amd_get_dismount_interval(path);
		else if (entry->maps)
			timeout = entry->maps->exp_timeout;
		else
			timeout = default_timeout;
	}

	if (!entry->ap) {
		ret = master_add_autofs_point(entry, logopt, nobind, ghost, 0);
		if (!ret) {
			error(m_logopt, "failed to add autofs_point");
			if (new)
				master_free_mapent(new);
			local_free_vars();
			return 0;
		}
	}
	if (random_selection)
		entry->ap->flags |= MOUNT_FLAG_RANDOM_SELECT;
	if (use_weight)
		entry->ap->flags |= MOUNT_FLAG_USE_WEIGHT_ONLY;
	if (symlnk)
		entry->ap->flags |= MOUNT_FLAG_SYMLINK;
	if (negative_timeout)
		entry->ap->negative_timeout = negative_timeout;
	if (mode && mode < LONG_MAX)
		entry->ap->mode = mode;

/*
	source = master_find_map_source(entry, type, format,
					local_argc, (const char **) local_argv); 
	if (!source)
		source = master_add_map_source(entry, type, format, age, 
					local_argc, (const char **) local_argv);
	else
		source->age = age;
*/
	source = master_add_map_source(entry, type, format, age, 
					local_argc, (const char **) local_argv);
	if (!source) {
		error(m_logopt, "failed to add source");
		if (new)
			master_free_mapent(new);
		local_free_vars();
		return 0;
	}
	source->exp_timeout = timeout;
	source->master_line = lineno;

	entry->age = age;
	entry->current = NULL;

	if (new)
		master_add_mapent(master, entry);

	local_free_vars();

	return 1;
}

